package xlogo;

import java.awt.Color;

import javax.swing.JOptionPane;
import javax.swing.JTextArea;

/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
**/


public class MemoryChecker extends Thread{
	private Application cadre;
	private boolean continuer;
	public MemoryChecker(Application cadre){
		this.cadre=cadre;
		continuer=true;
	}
	public void run(){
	while(continuer){
		try{
			Thread.sleep(1000);			
		}
		catch(InterruptedException e){}
		long free=Runtime.getRuntime().freeMemory();
		long total=Runtime.getRuntime().totalMemory();
		long memoire_utilisee=(total-free)/1024/1024;
//		System.out.println(memoire_utilisee);
		if (memoire_utilisee>0.9*Config.memoire){
			cadre.error=true;
			continuer=false;
			String message=Logo.messages.getString("depassement_memoire");
			JTextArea jt=new JTextArea(message);
			jt.setEditable(false);
			jt.setBackground(new Color(255,255,177));
			jt.setFont(Config.police);
	      JOptionPane.showMessageDialog(cadre,jt,Logo.messages.getString("erreur"),JOptionPane.ERROR_MESSAGE);

		}
	}
	}
	public void setContinuer(boolean b){
		continuer=b;
	}

}
